#! /bin/bash

# (c) IVK
# Write key phrase into memory many times. Write phrase into file for analize.
# License: GPL

# liME check
if [ -f /lib/modules/$(uname -r)/misc/lime.ko ] ; then
    LIMEPATH=/misc/lime.ko
elif [ -f /lib/modules/$(uname -r)/kernel/security/lime/lime.ko ] ; then
	LIMEPATH=/kernel/security/lime/lime.ko
else
    echo "LiME not found"
    exit 1
fi

if [ "$1" = "-h" -o  $# -ne "4" ] ; then
    echo "Usage: ${0##*/} count keyfile pre-dump-file dump-file"
    exit 1
fi

COUNT=$1
KEYFILE=$2
PRE=$3
POST=$4

# Make a 1st dump
insmod /lib/modules/$(uname -r)/${LIMEPATH} "format=raw path=$PRE"
rmmod lime

# Produce a key
KEY=`head -c 200 /dev/urandom | base64 | tr -dc '[:alnum:]' | head -c 100`

# Fill a memory
pool=()
i=0
while [ $((i++)) -lt $COUNT ] ; do
    pool+=(${KEY})
done

# Save a key 2 file
echo $KEY > $KEYFILE

# Make a 2nd dump
insmod /lib/modules/$(uname -r)/${LIMEPATH} "format=raw path=$POST"
rmmod lime

